﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;

namespace WebApplication2
{
    public partial class DB : System.Web.UI.Page
    {
        protected string connectionString = "Data Source=.;Initial Catalog=test;Integrated Security=True";
        protected SqlConnection connection;
        protected SqlDataAdapter da;
        protected DataTable dt;
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                connection = new SqlConnection(connectionString);
                connection.Open();
                da = new SqlDataAdapter("", connection);
                da.SelectCommand.CommandText = "SELECT code,details,price FROM goods";
                dt = new DataTable();
                da.Fill(dt);
                goods_list.DataSource = dt;
                goods_list.DataTextField = "details";
                goods_list.DataValueField = "code";
                goods_list.DataBind();
                Session.Add("DataTable", dt);
                Session.Add("Connection", connection);
            }
            else
            {
                dt = (DataTable)Session["DataTable"];
                connection = (SqlConnection)Session["connection"];
            }
        }
        protected void AddClick(object sender, EventArgs e)
        {
            string code = goods_list.SelectedValue;
            string text = goods_list.SelectedItem.Text;
            int index = goods_list.SelectedIndex;
            int prc = (int)(dt.Rows[index]["price"]);
            prc += int.Parse(price.Text);
            price.Text = prc.ToString();
            ListItem item = new ListItem(text, code);
            selectedgoods.Items.Add(item);
        }
        protected void InsertClick(object sender, EventArgs e)
        {
            SqlCommand cmd = new SqlCommand("", connection);
            cmd.CommandText = "INSERT INTO bill(total) VALUES(@total)";
            cmd.Parameters.AddWithValue("@total", price.Text);
            cmd.ExecuteNonQuery();
            foreach (ListItem li in selectedgoods.Items)
            {
                cmd.CommandText = "INSERT INTO bill_details(bill_id,good_id) SELECT MAX(id),@goodid FROM bill";
                cmd.Parameters.Clear();
                cmd.Parameters.AddWithValue("@goodid", li.Value);
                cmd.ExecuteNonQuery();
            }
        }

        protected void save_button_Click(object sender, EventArgs e)
        {
            SqlCommand cmd = new SqlCommand("", connection);
            cmd.CommandText = "UPDATE goods SET price=@price, details=@details WHERE code=@code";
            cmd.Parameters.AddWithValue("@price", edit_price.Text);
            cmd.Parameters.AddWithValue("@code", goods_list.SelectedValue);
            cmd.Parameters.AddWithValue("details", edit_name.Text);
            cmd.ExecuteNonQuery();
            dt.Rows[goods_list.SelectedIndex]["price"] = edit_price.Text;
            dt.Rows[goods_list.SelectedIndex]["details"] = edit_name.Text;
            goods_list.Items[goods_list.SelectedIndex].Text = edit_name.Text;
            edit_panel.Visible = false;
        }

        protected void edit_button_Click(object sender, EventArgs e)
        {
            edit_panel.Visible = true;
            edit_price.Text = dt.Rows[goods_list.SelectedIndex]["price"].ToString();
            edit_name.Text = dt.Rows[goods_list.SelectedIndex]["details"].ToString();
        }

        protected void remove_button_Click(object sender, EventArgs e)
        {
            SqlCommand cmd = new SqlCommand("", connection);
            cmd.CommandText = "DELETE FROM goods WHERE code=@code";
            cmd.Parameters.AddWithValue("@code", goods_list.SelectedValue);
            cmd.ExecuteNonQuery();
            dt.Rows.RemoveAt(goods_list.SelectedIndex);
            goods_list.Items.RemoveAt(goods_list.SelectedIndex);

        }

        protected void goods_list_SelectedIndexChanged(object sender, EventArgs e)
        {
            good_price.Text = dt.Rows[goods_list.SelectedIndex]["price"].ToString();
            good_name.Text = dt.Rows[goods_list.SelectedIndex]["details"].ToString();
        }
    }
}